from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util
from Property import Property

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('JAXRPCHandler')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereJAXRPCHandler");
  exportedObject.put("roleName", "WebSphereJAXRPCHandler");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.jaxrpchandler.name", objid, "name","JAXRPCHandler");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.jaxrpchandler.description", objid, "description","JAXRPCHandler");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.jaxrpchandler.handlerclassname", objid, "handlerClassName","JAXRPCHandler");
  Util.addAttributePathPropertyToJson(roleProperties, "websphere.jaxrpchandler.soaproles", objid, "soapRoles","JAXRPCHandler");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  typeFolders = {};
  extraObjects = Property.exportProperties(objid, respath, extraObjects, typeFolders, 'property',"JAXRPCHandler");
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('JAXRPCHandler');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('JAXRPCHandler')
  if not jsonobject.has("roleProperties"):
    raise Exception("JAXRPCHandler resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "name", roleProperties.optString("websphere.jaxrpchandler.name", None));
  Util.addIfNotNone(properties, "description", roleProperties.optString("websphere.jaxrpchandler.description", None));
  Util.addIfNotNone(properties, "handlerClassName", roleProperties.optString("websphere.jaxrpchandler.handlerclassname", None));
  Util.addPathProperty(properties, "soapRoles", roleProperties.optString("websphere.jaxrpchandler.soaproles", None));
  print "Creating JAXRPCHandler with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("JAXRPCHandler", parentid, properties);
  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString("roleName");
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('JAXRPCHandler');

def update(objid,jsonobject):
  Util.pushPathElement('JAXRPCHandler')
  if not jsonobject.has("roleProperties"):
    raise Exception("JAXRPCHandler resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.jaxrpchandler.name", None), "name","JAXRPCHandler");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.jaxrpchandler.description", None), "description","JAXRPCHandler");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.jaxrpchandler.handlerclassname", None), "handlerClassName","JAXRPCHandler");
  Util.addPathAttIfChanged(objid, atts, roleProperties.optString("websphere.jaxrpchandler.soaproles", None), "soapRoles","JAXRPCHandler");
  if len(atts) != 0:
    print "Modifying JAXRPCHandler with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "JAXRPCHandler configuration up to date.";

  Property.removeProperties(objid, 'property',"JAXRPCHandler");

  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString("roleName");
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('JAXRPCHandler');
